class PollData:
    POLL_ACTIVE_OBJECT_TYPE = {
        'prefix': 'C.object and C.object.type == ',
        'suffix': '',
        'name': 'Active Item Object Type',
        'items': [
            {'name': 'Mesh', 'item': 'MESH', },
            {'name': 'Curve', 'item': 'CURVE', },
            {'name': 'Hair Curves', 'item': 'CURVES', },
            {'name': 'Surface', 'item': 'SURFACE', },
            {'name': 'Metaball', 'item': 'META', },
            {'name': 'Text', 'item': 'FONT', },
            {'name': 'Point Cloud', 'item': 'POINTCLOUD', },
            {'name': 'Volume', 'item': 'VOLUME', },
            {'name': 'Grease Pencil', 'item': 'GPENCIL', },
            {'name': 'Armature', 'item': 'ARMATURE', },
            {'name': 'Lattice', 'item': 'LATTICE', },
            {'name': 'Empty', 'item': 'EMPTY', },
            {'name': 'Light', 'item': 'LIGHT', },
            {'name': 'Light Probe', 'item': 'LIGHT_PROBE', },
            {'name': 'Camera', 'item': 'CAMERA', },
            {'name': 'Speaker', 'item': 'SPEAKER', }, ],
    }

    POLL_MODE_TYPE = {
        'prefix': 'C.mode == ',
        'suffix': '',
        'name': 'object mode',
        'items': [
            {'name': 'Mesh Edit', 'item': 'EDIT_MESH'},
            {'name': 'Curve Edit', 'item': 'EDIT_CURVE'},
            {'name': 'Curves Edit', 'item': 'EDIT_CURVES'},
            {'name': 'Curves Sculpt', 'item': 'SCULPT_CURVES'},
            {'name': 'Surface Edit', 'item': 'EDIT_SURFACE'},
            {'name': 'Text Edit', 'item': 'EDIT_TEXT'},
            {'name': 'Armature Edit', 'item': 'EDIT_ARMATURE'},
            {'name': 'Metaball Edit', 'item': 'EDIT_METABALL'},
            {'name': 'Lattice Edit', 'item': 'EDIT_LATTICE'},
            None,

            {'name': 'Pose', 'item': 'POSE'},
            {'name': 'Sculpt', 'item': 'SCULPT'},
            {'name': 'Weight Paint', 'item': 'PAINT_WEIGHT'},
            {'name': 'Vertex Paint', 'item': 'PAINT_VERTEX'},
            {'name': 'Texture Paint', 'item': 'PAINT_TEXTURE'},
            {'name': 'Particle', 'item': 'PARTICLE'},
            {'name': 'Object', 'item': 'OBJECT'},
            None,

            {'name': 'Grease Pencil Paint',
             'item': 'PAINT_GPENCIL'},
            {'name': 'Grease Pencil Edit', 'item': 'EDIT_GPENCIL'},
            {'name': 'Grease Pencil Sculpt',
             'item': 'SCULPT_GPENCIL'},
            {'name': 'Grease Pencil Weight Paint',
             'item': 'WEIGHT_GPENCIL'},
            {'name': 'Grease Pencil Vertex Paint',
             'item': 'VERTEX_GPENCIL'},
            {'name': 'Curves Sculpt', 'item': 'SCULPT_CURVES'},
        ],
    }

    POLL_MESH_SELECT_MODE = {
        'prefix': 'tool.mesh_select_mode[:] == ',
        'suffix': '',
        'name': 'grid selection mode',
        'items': [
            # {'prefix': '', 'suffix': '',
            #  'item': 'is_select_vert', 'name': '选中了顶点', },
            # None,

            {'prefix': 'tool.mesh_select_mode[0] == ',
             'item': True, 'name': '顶点', },
            {'prefix': 'tool.mesh_select_mode[1] == ',
             'item': True, 'name': '边', },
            {'prefix': 'tool.mesh_select_mode[2] == ',
             'item': True, 'name': '面', },
            None,
            {'item': [True, False, False], 'name': 'vertices only', },
            {'item': [False, True, False], 'name': 'edges only', },
            {'item': [False, False, True], 'name': 'faces only', },
            None,
            {'item': [True, False, True], 'name': 'vertices & faces only', },
            {'item': [False, True, True], 'name': 'edges & faces only', },
            {'item': [True, True, False], 'name': 'vertices & edges only', },
            {'item': [True, True, True], 'name': 'vertices & edges & faces', },
        ],
    }
    POLL_REGIONS_TYPE = {
        'prefix': 'C.region.type == ',
        'suffix': '',
        'name': 'region type',
        'items': [
            {'item': 'WINDOW', 'name': 'Window', },
            {'item': 'HEADER', 'name': 'Header', },
            {'item': 'CHANNELS', 'name': 'Channels', },
            {'item': 'TEMPORARY', 'name': 'Temporary', },
            {'item': 'EXECUTE', 'name': 'Execute Buttons', },
            {'item': 'UI', 'name': 'UI', },
            {'item': 'TOOLS', 'name': 'Tools', },
            {'item': 'TOOL_PROPS', 'name': 'Tool Properties', },
            {'item': 'PREVIEW', 'name': 'Preview', },
            {'item': 'HUD', 'name': 'Floating Region', },
            {'item': 'NAVIGATION_BAR', 'name': 'Navigation Bar', },
            {'item': 'FOOTER', 'name': 'Footer', },
            {'item': 'TOOL_HEADER', 'name': 'Tool Header', },
            {'item': 'XR', 'name': 'XR', },
        ],
    }
    POLL_SPACE_TYPE = {
        'prefix': 'C.space_data.type == ',
        'suffix': '',
        'name': 'the type of space',
        'items': [
            {'name': 'Empty', 'item': 'EMPTY', },
            {'name': '3D Viewport', 'item': 'VIEW_3D', },
            {'name': 'UV/Image Editor', 'item': 'IMAGE_EDITOR', },
            {'name': 'Node Editor', 'item': 'NODE_EDITOR', },
            {'name': 'Video Sequencer', 'item': 'SEQUENCE_EDITOR', },
            {'name': 'Movie Clip Editor', 'item': 'CLIP_EDITOR', },
            {'name': 'Dope Sheet', 'item': 'DOPESHEET_EDITOR', },
            {'name': 'Graph Editor', 'item': 'GRAPH_EDITOR', },
            {'name': 'Nonlinear Animation', 'item': 'NLA_EDITOR', },
            {'name': 'Text Editor', 'item': 'TEXT_EDITOR', },
            {'name': 'Python Console', 'item': 'CONSOLE', },
            {'name': 'Info', 'item': 'INFO', },
            {'name': 'Top Bar', 'item': 'TOPBAR', },
            {'name': 'Status Bar', 'item': 'STATUSBAR', },
            {'name': 'Outliner', 'item': 'OUTLINER', },
            {'name': 'Properties', 'item': 'PROPERTIES', },
            {'name': 'File Browser', 'item': 'FILE_BROWSER', },
            {'name': 'Spreadsheet', 'item': 'SPREADSHEET', },
            {'name': 'Preferences', 'item': 'PREFERENCES', },
        ],
    }
    POLL_OTHER = {
        'prefix': '',
        'suffix': '',
        'name': ''
                'other',
        'items': [
            {'item': ' and ',
             'name': 'and',
             'parentheses': False,
             'not_str': True},
            {'item': ' or ',
             'name': 'or',
             'parentheses': False,
             'not_str': True},
            {'item': ' not ',
             'name': 'not',
             'parentheses': False,
             'not_str': True},
            None,
            {'item': 'len(C.objects)',
             'name': 'the object s is selected',
             'parentheses': False,
             'not_str': True},
        ],
    }

    POLL_ALL_LIST = [POLL_MODE_TYPE,
                     POLL_ACTIVE_OBJECT_TYPE,
                     POLL_MESH_SELECT_MODE,
                     None,
                     POLL_SPACE_TYPE,
                     POLL_REGIONS_TYPE,
                     POLL_OTHER
                     ]
